<template>
  <q-page class="flex flex-center">
     <PatientCard :patient="patient"
     :patientId="patientId"
     :acties="acties"
     v-on:deleteOpm="deleteOpm"
     v-on:addOpm="addOpm"
     v-on:addActie="addActie"
     v-on:uitgevoerd="setUitgevoerd"
     v-on:editActie="updateActie"
    v-on:deleteActie="deleteActie"
     v-on:updatePatient="updatePatient"
     ></PatientCard>
  </q-page>
</template>

<script>
import PatientCard from '../components/PatientCard'
import PatientService from '../services/PatientService'
import ActiesService from '../services/ActiesService'
import ErrorService from '../services/ErrorService'
import Utils from '../utils'

export default {
  name: 'Patient',
  components: {
    PatientCard
  },
  data () {
    return {
      value: true,
      patientId: this.$route.params.id,
      patient: [Object, Function],
      acties: []
    }
  },
  // bij elke route update bv van patient/1 naar patient/2 zal de patientId ook mee veranderen om zo gegevens te krijgen over de nieuwe patiënt
  beforeRouteUpdate (to, from, next) {
    this.patientId = to.params.id
    this.loadPatient()
    next()
  },
  methods: {
    async loadPatient () {
      try {
        this.patient = await this.patientservice.getById(this.patientId)
        this.acties = await this.actiesService.getByPatientId(this.patientId)
      } catch (error) {
        ErrorService.showAlert('Ophalen patiënt mislukt')
      }
    },
    async deleteOpm (opmerking) {
      this.patient.opmerkingen = Utils.removeFromArray(this.patient.opmerkingen, opmerking)
      try {
        await this.patientservice.update(this.patient)
      } catch (error) {
        ErrorService.showAlert('Verwijderen opmerking van patiënt mislukt')
      }
    },
    async addOpm (opmerking) {
      if (opmerking !== '') {
        this.patient.opmerkingen.push(opmerking)
        try {
          await this.patientservice.update(this.patient)
        } catch (error) {
          ErrorService.showAlert('Toevoegen opmerking van patiënt mislukt')
        }
      }
    },
    async addActie (actie) {
      actie.patientId = this.patientId
      try {
        await this.actiesService.add(actie)
        this.acties.push(actie)
      } catch (error) {
        ErrorService.showAlert('Toevoegen actie van patiënt mislukt')
      }
    },
    async setUitgevoerd (actie) {
      try {
        await this.actiesService.update(actie)
      } catch (error) {
        ErrorService.showAlert('Actie Uitgevoerd zetten van patiënt mislukt')
      }
    },
    async updatePatient (vega) {
      this.patient.Vegetarisch = vega
      try {
        await this.patientservice.update(this.patient)
      } catch (error) {
        ErrorService.showAlert('Updaten vegetarisch van patiënt mislukt')
      }
    },
    async deleteActie (actie) {
      try {
        await this.actiesService.delete(actie)
        this.acties = Utils.removeActieFromArray(this.acties, actie)
      } catch (error) {
        ErrorService.showAlert('Verwijderen actie van patiënt mislukt')
      }
    },
    async updateActie (actie) {
      try {
        await this.actiesService.update(actie)
      } catch (error) {
        ErrorService.showAlert('Updaten actie van patiënt mislukt')
      }
    }
  },
  created () {
    this.patientservice = new PatientService()
    this.actiesService = new ActiesService()
    this.loadPatient()
  }
}
</script>
